#include <stdio.h>
#include <stdlib.h>
#include <assert.h>
#include <string.h>
#include "mcutil/mcutil.h"
#include "mcutil/collect/gen_vec.h"

#define MCU_GEN_VEC_INITIAL_SIZE 32

MCU_API void mcu_gen_vec_init(mcu_gen_vec_t* gv) {
    gv->inner = MCU_ALLOC(sizeof(void*)*MCU_GEN_VEC_INITIAL_SIZE); 
    gv->capacity  = MCU_GEN_VEC_INITIAL_SIZE;
}


MCU_API void mcu_gen_vec_insert_front(mcu_gen_vec_t* gv, void* data) {
    assert(gv && "Null ptr passed as mcu_gen_vec_t");
    if (!gv->inner) mcu_gen_vec_init(gv);
    if (gv->count == gv->capacity) {
        gv->inner = MCU_REALLOC(gv->inner, (gv->capacity * sizeof(void*)) * 2);
        gv->capacity *= 2;
    }

    size_t count = sizeof(void*)*gv->count;
    void* tmp = MCU_ALLOC(count);
    memcpy(tmp, gv->inner, count);
    memcpy(gv->inner + sizeof(void*), tmp, count);
    gv->inner[0] = data;
    gv->count += 1;
    MCU_FREE(tmp);
}

MCU_API void mcu_gen_vec_insert_back(mcu_gen_vec_t* gv, void* data) {
    assert(gv && "Null ptr passed as mcu_gen_vec_t");
    if (!gv->inner) mcu_gen_vec_init(gv);
    if (gv->count == gv->capacity) {
        gv->inner = MCU_REALLOC(gv->inner, (gv->capacity * 2) * sizeof(void*));
        gv->capacity *= 2;
    }
    gv->inner[gv->count++] = data;
}

MCU_API void* mcu_gen_vec_remove_back(mcu_gen_vec_t *gv) {
    assert(gv && "Null ptr passed as mcu_gen_vec_t");
    if (gv->count == 0) return NULL;
    return gv->inner[--gv->count];
}

MCU_API void* mcu_gen_vec_remove_front(mcu_gen_vec_t *gv) {
    assert(gv && "Null ptr passed as mcu_gen_vec_t");
    if (gv->count == 0) return NULL;
    void* data = gv->inner[0];
    for (int i = 0; i < gv->count; i++) {
       gv->inner[i] = gv->inner[i + 1];
    }
    gv->count--;
    return data;
}
